<?php
// ColourNull.php
// Created: 2023-01-02
// Updated: 2023-11-09

namespace Index\Colour;

/**
 * Represents an empty colour.
 *
 * If possible, use Colour::empty() to get the global instance of this class.
 */
class ColourNull extends Colour {
    public function getRed(): int {
        return 0;
    }

    public function getGreen(): int {
        return 0;
    }

    public function getBlue(): int {
        return 0;
    }

    public function getAlpha(): float {
        return 1;
    }

    public function shouldInherit(): bool {
        return true;
    }

    public function __toString(): string {
        return 'inherit';
    }
}
